path(path,'rwt');

% read image
%f = 255-double(imread('Diffusion.bmp'));
f = ones(512)*128;
%f(6:508,6:508) = double(imread('StLouis.gif'))/2+64;
f(6:508,6:508) = double(imread('StLouis.gif'));

C_l = 0;
C_u = 255;

n = size(f,1);
gamma = 70;
S = (f >= gamma);
R_S = sum(((gamma-f(:)).*(2*S(:)-1)-C_l)/(C_u-C_l));

%noise_var = 64^2/12;
noise_var = 3000;
C_u = 255+sqrt(noise_var*12)/2;
C_l = 0-sqrt(noise_var*12)/2;
[C_l C_u]

y = f + (rand(size(f))-0.5)*sqrt(noise_var*12);

Sy = (y >= gamma);
R_Sy = sum(((gamma-f(:)).*(2*Sy(:)-1)-C_l)/(C_u-C_l));


weightMin = zeros(10,1);

in = 0;
for noise_var = linspace(0,3000,20)
  in = in+1
  
  if (noise_var == 0)
    weightMin(in) = 0;
  else
    y = f + (rand(size(f))-0.5)*sqrt(noise_var*12);
  
    Rmin = realmax;
    for weight = linspace(0,.015,21)
      S_hat = levelSet2DTI(y,gamma,1/n/n,weight);
      R = sum(((gamma-f(:)).*(2*S_hat(:)-1)-C_l)/(C_u-C_l))-R_S;
      if R < Rmin
        Rmin = R;
        weightMin(in) = weight;
        weight
      end
    end
  end
  save findWeight
end

noise_var = linspace(0,3000,20)';
figure(2);plot(noise_var,weightMin);
hold on;
plot(noise_var,noise_var*mean(weightMin./(noise_var+realmin)),'g');
plot(noise_var,noise_var.^(0.5)*mean(weightMin./(noise_var.^0.5+realmin)),'m');
%plot(noise_var,log(noise_var+realmin)*mean(weightMin./log(noise_var+realmin)),'m');
p = polyfit(noise_var,weightMin,2);
w = polyval(p,noise_var);
plot(noise_var,w,'k');
return

%Rmin = realmax;
%for delta = linspace(0,1e8,100)
%  S_hat = levelSet2D(y,gamma,delta);
%  R = sum(((gamma-f(:)).*(2*S_hat(:)-1)-C_l)/(C_u-C_l))-R_S;
%  if R < Rmin
%    Rmin = R;
%    deltaMin = delta;
%  end
%end

%weightMin = (3e-4)*sqrt(noise_var);
weightMin = (1e-5)*noise_var;
S_hat = levelSet2DTI(y,gamma,1/n/n,0.02);
%deltaMin = 1e6;
%S_hat = levelSet2D(y,gamma,deltaMin);


g_hat = S_hat*255;

R_Shat = sum(((gamma-f(:)).*(2*S_hat(:)-1)-C_l)/(C_u-C_l));

%S_hat2 = cell(5,1);
%delta = 1./logspace(0,20,5);
%for k = 1:5
%  S_hat2{k} = levelSet2D(y,gamma,delta(k))*255;
%end%

%figure(2);imagesc([S_hat2{:}],[0,255]);
%colormap(gray(512));axis image;

h = daubcqf(2);
%w = mdwt(y,h);
[wL,wH] = mrdwt(y,h);


%Rmin = realmax;
%for thresh = linspace(0,6*sqrt(noise_var),100)
%  f_hat = midwt(HardTh(w,thresh),h);
%  S_denoise = (f_hat >= gamma);
%  R = sum(((gamma-f(:)).*(2*S_denoise(:)-1)-C_l)/(C_u-C_l))-R_S;
%  %R = sum((f(:)-f_hat(:)).^2);
%  %fprintf('%d,\t%d\n',thresh,R);
%  if R < Rmin
%    Rmin = R;
%    threshMin = thresh;
%  end
%end

%%% to minimize MSE
%threshMin = 3.45*sqrt(noise_var);
%%% to minimize R
threshMin = 3.7*sqrt(noise_var);
%f_hat = midwt(HardTh(w,threshMin),h);
f_hat = mirdwt(wL,HardTh(wH,threshMin),h);

figure(2);imagesc([f y f_hat],[0 255]);
axis image;colormap(gray(512));

S_denoise = (f_hat >= gamma);
g_denoise = S_denoise*255;

figure(1);imagesc([f,g,y; gy g_hat g_denoise;...
		  abs([f.*(g-gy) f.*(g-g_hat) f.*(g-g_denoise)]/255)],[0,255]);
colormap(gray(512));axis image;

R_Sdenoise = sum(((gamma-f(:)).*(2*S_denoise(:)-1)-C_l)/(C_u-C_l));
fprintf('R(S_y)-R(S) = %f\n',R_Sy-R_S);
fprintf('R(S_hat)-R(S) = %f\n',R_Shat-R_S);
fprintf('R(S_denoise)-R(S) = %f\n',R_Sdenoise-R_S);


%R_becca = 0;
%R_wavelet = 0;
%maxIter = 100;
%for iter = 1:maxIter
%  S_becca = levelSet2D(y,gamma,1/n/n,weightMin);
%  R_becca = R_becca + ...
%	    (sum(((gamma-f(:)).*(2*S_becca(:)-1)-C_l)/(C_u-C_l))-R_S)/ ...
%	    maxIter;
%  f_hat = midwt(HardTh(w,threshMin),h);
%  S_wavelet = (f_hat >= gamma);
%  R_wavelet = R_wavelet + ...
%	    (sum(((gamma-f(:)).*(2*S_wavelet(:)-1)-C_l)/(C_u-C_l))-R_S)/ ...
%	    maxIter;
%  [R_becca R_wavelet]
%end

R_becca = 128.15
R_wavelet = 225.63